import os
import datetime
import csv
import json
import datetime
import pdb

import dateparser
from bingads.v13.reporting import *
from bingads.authorization import AuthorizationData
from bing_content_api.api import BingContentApi
from shopping_utils.bing_shopping import BingShopping

from em_tasks import logger
from em_tasks.store.models import *


class BingAuth():
  def __init__(self, account_id, environment='production', version=13):
    self.ba_account = BingAdsAccount.get_or_none(BingAdsAccount.account_id == account_id)
    self.active = self.ba_account and self.ba_account.active
    if not self.active:
      return

    self.ba_id = self.ba_account.id
    self.account_id = account_id
    customer_id = self.ba_account.customer_id
    # self.merchant_id = ba_account.merchant_id
    client_id = self.ba_account.client_id
    developer_token = self.ba_account.developer_token
    refresh_token = self.ba_account.refresh_token
    refresh_token = None

    # self.api = BingContentApi(client_id, developer_token, None, refresh_token, environment)
    self.bs = BingShopping(None, client_id, developer_token, refresh_token)

  def run(self):
    if not self.active:
      return

    token = self.bs.get_refresh_token()
    self.ba_account.refresh_token = token.refresh_token
    self.ba_account.save()
