import json

from shopping_utils.google_shopping import GoogleShopping

from em_tasks import logger
from em_tasks.store.models import *


class GmcUpdateProductsExpirationTask():
  def __init__(self, merchant_id, days_before_expire=14):
    self.merchant_id = merchant_id
    self.days_before_expire = days_before_expire
    self.gs = None
    self.gmc_store = GmcStore.get_or_none(GmcStore.merchant_id == merchant_id)
    if not self.gmc_store:
      return

    self.gs = GoogleShopping(merchant_id, json.loads(self.gmc_store.service_account_data))

  def run(self):
    if not self.gmc_store or not self.gs:
      return

    self.gs.update_expiration(self.days_before_expire)
