import os
import json

import ahocorasick

from em_tasks.store.models import *


class BlacklistFilter():
  def __init__(self):
    # self.filter_cache_path = os.path.abspath(os.path.expanduser('~'), '.em_tasks', 'blacklist_filter.json')
    # filter_cache_dir = os.path.dirname(self.filter_cache_path)
    # if not os.path.isdir(filter_cache_dir):
    #   os.makedirs(filter_cache_dir)

    self.automaton = ahocorasick.Automaton()
    idx = 0
    for keyword in BlacklistKeyword.select().order_by(BlacklistKeyword.id.desc()).dicts():
      k = keyword['keywords'].strip().lower()
      if not k:
        continue

      k = '{} '.format(k)
      self.automaton.add_word(k, (idx, k))
      idx += 1

    for keyword in self.cloth_keywords():
      self.automaton.add_word(k, (idx, k))
      idx += 1

    for keyword in self.adult_keywords():
      self.automaton.add_word(k, (idx, k))
      idx += 1

    self.automaton.make_automaton()

  def is_blacklisted(self, s):
    end_idx, (pos, val) = next(self.automaton.iter(s), (None, (None, None)))
    if not val:
      return False

    return val

  def cloth_keywords(self):
    return [
      "dress", "shirt", "pants", "jeans", "skirt", "blouse", "sweater", "jacket",
      "coat", "shoes", "boots", "sandals", "sneakers", "heels", "hat", "scarf",
      "gloves", "socks", "t-shirt", "hoodie", "shorts", "swimsuit", "bikini",
      "underwear", "bra", "panty", "panties", "socks", "tie", "belt", "handbag", "purse",
      "backpack", "jewelry", "watch", "sunglasses", "accessories", "fashion",
      "apparel", "clothing", "garment", "outfit", "style", "trend", "vintage",
      "designer", "luxury", "athletic", "sportswear", "yoga", "activewear", "denim",
      "cotton", "leather", "silk", "wool", "linen", "polyester", "nylon", "spandex"
    ]

  def adult_keywords(self):
    return [
      "Lingerie", "Vibrators", "Dildos", "Rings", "Massagers", "Harnesses",
      "Blindfolds", "Restraints", "Gags", "Whips", "Cuffs", "Lubes", "Condoms",
      "Erotic furniture", "Silicone", "Latex", "Glass", "Feather", "Faux leather",
      "Water-based", "Silicone-based", "Hybrid"
    ]

  # def load_cache(self):
  #   if not os.path.isfile(self.filter_cache_path):
  #     return

  #   with open(self.filter_cache_path, encoding='utf-8', errors='ignore') as fh:
  #     s = fh.read().strip()
  #     filter_cache = json.loads(s)
  #     if 'keywords' not in filter_cache or not filter_cache['keywords']:
  #       return
