# -*- coding: utf-8 -*-

from em_tasks import logger
from em_tasks.utils.product_service import ProductService
from em_tasks.store.store_util import StoreUtil
from em_tasks.store.models import *


class DangdangUploadableProductsFilter():
  def __init__(self, product_service):
    self.product_service = product_service
    self.indice_name = 'dangdang_products'

  def filter(self):
    uploaded_prods = dict()
    for prod in StoreUtil.get_dangdang_products():
      uploaded_prods[prod['source_product_id']] = None

    logger.debug('[UploadedProductsLoaded] ProductsCnt: %s', len(uploaded_prods))

    for prod_id, prod in self.product_service.load_products(self.indice_name):
      exist = prod.get('existence', True)
      if not exist:
        continue

      if prod_id in uploaded_prods:
        continue

      yield (prod_id, prod)
