# -*- coding: utf-8 -*-

from em_tasks import logger


class EbayProductFormatter():
  def __init__(self, marketplace, product_service, price_caculator):
    self.marketplace = marketplace
    self.product_service = product_service
    self.price_calc = price_caculator
    self.indice_name = 'ebay_{}_products'.format(marketplace.lower())

  def format_products(self, product_ids):
    products_info = self.product_service.search_products(self.indice_name, product_ids)
    if not products_info:
      return

    prods = dict()
    for product_id, product_info in products_info.items():
      prod = dict(product_info)

      src_offer = {'price': round(float(product_info.get('price', 0)), 2), 'currency': product_info.get('currency', 'USD')}
      prod['cost_price'] = src_offer['price']
      prod['cost_currency'] = src_offer['currency']

      offer = self.price_calc.calc_offer(src_offer)
      if offer:
        prod['price'] = offer['price']
        prod['quantity'] = offer['quantity']
      else:
        prod['price'] = 0
        prod['quantity'] = 0

      prods[product_id] = prod

    return prods
