from urllib.parse import urlparse

from em_tasks.utils.pipelines.base import BasePipeline


class ImageUrlCorrectorPipeline(BasePipeline):
  def execute(self, product):
    images = product.get('images', None)
    if images:
      image_urls = []
      for image_url in images.split(';'):
        parsed = urlparse(image_url)
        if not parsed.scheme:
          image_urls.append(parsed._replace(scheme='https').geturl())
      if image_urls:
        product['images'] = ';'.join(image_urls)

    variants = product.get('variants', None)
    if not variants:
      return product

    for variant in product['variants']:
      images = variant.get('images', None)
      if images:
        image_urls = []
        for image_url in images.split(';'):
          parsed = urlparse(image_url)
          if not parsed.scheme:
            image_urls.append(parsed._replace(scheme='https').geturl())
        if image_urls:
          variant['images'] = ';'.join(image_urls)

    return product
