from em_tasks.utils.pipelines.base import BasePipeline


class SkuUpdaterPipeline(BasePipeline):
  def __init__(self, sku_from, sku_to):
    self.sku_from = sku_from
    self.sku_to = sku_to

  def execute(self, product):
    sku = product.get('sku', None)
    if sku and sku.find(self.sku_from) != -1:
      product['sku'] = sku.replace(self.sku_from, self.sku_to).replace('_', '-')
    else:
      product['sku'] = '{}-{}'.format(self.sku_to, sku)

    variants = product.get('variants', None)
    if not variants:
      return product

    for variant in product['variants']:
      sku = variant.get('sku', None)
      if not sku:
        continue

      if sku.find(self.sku_from) != -1:
        variant['sku'] = sku.replace(self.sku_from, self.sku_to).replace('_', '-')
      else:
        variant['sku'] = '{}-{}'.format(self.sku_to, sku)

    return product
