from em_tasks.utils.pipelines.base import BasePipeline
from checkdigit import isbn, gs1

from em_tasks import logger


class UpcValidatorPipeline(BasePipeline):
  def execute(self, product):
    upc = product.get('upc', None)
    if not upc:
      return product

    try:
      valid = gs1.validate(upc) or isbn.validate(upc)
    except:
      valid = False
    if not valid:
      product['upc'] = None

    return product
